import { ATN } from "antlr4ts/atn/ATN";
import { CharStream } from "antlr4ts/CharStream";
import { Lexer } from "antlr4ts/Lexer";
import { Vocabulary } from "antlr4ts/Vocabulary";
export declare class VtlLexer extends Lexer {
    static readonly LPAREN = 1;
    static readonly RPAREN = 2;
    static readonly QLPAREN = 3;
    static readonly QRPAREN = 4;
    static readonly GLPAREN = 5;
    static readonly GRPAREN = 6;
    static readonly EQ = 7;
    static readonly LT = 8;
    static readonly MT = 9;
    static readonly ME = 10;
    static readonly NEQ = 11;
    static readonly LE = 12;
    static readonly PLUS = 13;
    static readonly MINUS = 14;
    static readonly MUL = 15;
    static readonly DIV = 16;
    static readonly COMMA = 17;
    static readonly POINTER = 18;
    static readonly COLON = 19;
    static readonly ASSIGN = 20;
    static readonly MEMBERSHIP = 21;
    static readonly EVAL = 22;
    static readonly IF = 23;
    static readonly THEN = 24;
    static readonly ELSE = 25;
    static readonly USING = 26;
    static readonly WITH = 27;
    static readonly CURRENT_DATE = 28;
    static readonly ON = 29;
    static readonly DROP = 30;
    static readonly KEEP = 31;
    static readonly CALC = 32;
    static readonly ATTRCALC = 33;
    static readonly RENAME = 34;
    static readonly AS = 35;
    static readonly AND = 36;
    static readonly OR = 37;
    static readonly XOR = 38;
    static readonly NOT = 39;
    static readonly BETWEEN = 40;
    static readonly IN = 41;
    static readonly NOT_IN = 42;
    static readonly NULL_CONSTANT = 43;
    static readonly ISNULL = 44;
    static readonly EX = 45;
    static readonly UNION = 46;
    static readonly DIFF = 47;
    static readonly SYMDIFF = 48;
    static readonly INTERSECT = 49;
    static readonly KEYS = 50;
    static readonly INTYEAR = 51;
    static readonly INTMONTH = 52;
    static readonly INTDAY = 53;
    static readonly CHECK = 54;
    static readonly EXISTS_IN = 55;
    static readonly TO = 56;
    static readonly RETURN = 57;
    static readonly IMBALANCE = 58;
    static readonly ERRORCODE = 59;
    static readonly ALL = 60;
    static readonly AGGREGATE = 61;
    static readonly ERRORLEVEL = 62;
    static readonly ORDER = 63;
    static readonly BY = 64;
    static readonly RANK = 65;
    static readonly ASC = 66;
    static readonly DESC = 67;
    static readonly MIN = 68;
    static readonly MAX = 69;
    static readonly FIRST = 70;
    static readonly LAST = 71;
    static readonly INDEXOF = 72;
    static readonly ABS = 73;
    static readonly KEY = 74;
    static readonly LN = 75;
    static readonly LOG = 76;
    static readonly TRUNC = 77;
    static readonly ROUND = 78;
    static readonly POWER = 79;
    static readonly MOD = 80;
    static readonly LEN = 81;
    static readonly CONCAT = 82;
    static readonly TRIM = 83;
    static readonly UCASE = 84;
    static readonly LCASE = 85;
    static readonly SUBSTR = 86;
    static readonly SUM = 87;
    static readonly AVG = 88;
    static readonly MEDIAN = 89;
    static readonly COUNT = 90;
    static readonly DIMENSION = 91;
    static readonly MEASURE = 92;
    static readonly ATTRIBUTE = 93;
    static readonly FILTER = 94;
    static readonly MERGE = 95;
    static readonly EXP = 96;
    static readonly ROLE = 97;
    static readonly VIRAL = 98;
    static readonly CHARSET_MATCH = 99;
    static readonly TYPE = 100;
    static readonly NVL = 101;
    static readonly HIERARCHY = 102;
    static readonly OPTIONAL = 103;
    static readonly INVALID = 104;
    static readonly LEVENSHTEIN = 105;
    static readonly VALUE_DOMAIN = 106;
    static readonly VARIABLE = 107;
    static readonly DATA = 108;
    static readonly STRUCTURE = 109;
    static readonly DATASET = 110;
    static readonly OPERATOR = 111;
    static readonly DEFINE = 112;
    static readonly PUT_SYMBOL = 113;
    static readonly DATAPOINT = 114;
    static readonly HIERARCHICAL = 115;
    static readonly RULESET = 116;
    static readonly RULE = 117;
    static readonly END = 118;
    static readonly ALTER_DATASET = 119;
    static readonly LTRIM = 120;
    static readonly RTRIM = 121;
    static readonly INSTR = 122;
    static readonly REPLACE = 123;
    static readonly CEIL = 124;
    static readonly FLOOR = 125;
    static readonly SQRT = 126;
    static readonly ANY = 127;
    static readonly SETDIFF = 128;
    static readonly STDDEV_POP = 129;
    static readonly STDDEV_SAMP = 130;
    static readonly VAR_POP = 131;
    static readonly VAR_SAMP = 132;
    static readonly GROUP = 133;
    static readonly EXCEPT = 134;
    static readonly HAVING = 135;
    static readonly FIRST_VALUE = 136;
    static readonly LAST_VALUE = 137;
    static readonly LAG = 138;
    static readonly LEAD = 139;
    static readonly RATIO_TO_REPORT = 140;
    static readonly OVER = 141;
    static readonly PRECEDING = 142;
    static readonly FOLLOWING = 143;
    static readonly UNBOUNDED = 144;
    static readonly PARTITION = 145;
    static readonly ROWS = 146;
    static readonly RANGE = 147;
    static readonly CURRENT = 148;
    static readonly VALID = 149;
    static readonly FILL_TIME_SERIES = 150;
    static readonly FLOW_TO_STOCK = 151;
    static readonly STOCK_TO_FLOW = 152;
    static readonly TIMESHIFT = 153;
    static readonly MEASURES = 154;
    static readonly NO_MEASURES = 155;
    static readonly CONDITION = 156;
    static readonly BOOLEAN = 157;
    static readonly DATE = 158;
    static readonly TIME_PERIOD = 159;
    static readonly NUMBER = 160;
    static readonly STRING = 161;
    static readonly TIME = 162;
    static readonly INTEGER = 163;
    static readonly FLOAT = 164;
    static readonly LIST = 165;
    static readonly RECORD = 166;
    static readonly RESTRICT = 167;
    static readonly YYYY = 168;
    static readonly MM = 169;
    static readonly DD = 170;
    static readonly MAX_LENGTH = 171;
    static readonly REGEXP = 172;
    static readonly IS = 173;
    static readonly WHEN = 174;
    static readonly FROM = 175;
    static readonly AGGREGATES = 176;
    static readonly POINTS = 177;
    static readonly POINT = 178;
    static readonly TOTAL = 179;
    static readonly PARTIAL = 180;
    static readonly ALWAYS = 181;
    static readonly INNER_JOIN = 182;
    static readonly LEFT_JOIN = 183;
    static readonly CROSS_JOIN = 184;
    static readonly FULL_JOIN = 185;
    static readonly MAPS_FROM = 186;
    static readonly MAPS_TO = 187;
    static readonly MAP_TO = 188;
    static readonly MAP_FROM = 189;
    static readonly RETURNS = 190;
    static readonly PIVOT = 191;
    static readonly CUSTOMPIVOT = 192;
    static readonly UNPIVOT = 193;
    static readonly SUBSPACE = 194;
    static readonly APPLY = 195;
    static readonly CONDITIONED = 196;
    static readonly PERIOD_INDICATOR = 197;
    static readonly SINGLE = 198;
    static readonly DURATION = 199;
    static readonly TIME_AGG = 200;
    static readonly UNIT = 201;
    static readonly VALUE = 202;
    static readonly VALUEDOMAINS = 203;
    static readonly VARIABLES = 204;
    static readonly INPUT = 205;
    static readonly OUTPUT = 206;
    static readonly CAST = 207;
    static readonly RULE_PRIORITY = 208;
    static readonly DATASET_PRIORITY = 209;
    static readonly DEFAULT = 210;
    static readonly CHECK_DATAPOINT = 211;
    static readonly CHECK_HIERARCHY = 212;
    static readonly COMPUTED = 213;
    static readonly NON_NULL = 214;
    static readonly NON_ZERO = 215;
    static readonly PARTIAL_NULL = 216;
    static readonly PARTIAL_ZERO = 217;
    static readonly ALWAYS_NULL = 218;
    static readonly ALWAYS_ZERO = 219;
    static readonly COMPONENTS = 220;
    static readonly ALL_MEASURES = 221;
    static readonly SCALAR = 222;
    static readonly COMPONENT = 223;
    static readonly DATAPOINT_ON_VD = 224;
    static readonly DATAPOINT_ON_VAR = 225;
    static readonly HIERARCHICAL_ON_VD = 226;
    static readonly HIERARCHICAL_ON_VAR = 227;
    static readonly SET = 228;
    static readonly LANGUAGE = 229;
    static readonly INTEGER_CONSTANT = 230;
    static readonly NUMBER_CONSTANT = 231;
    static readonly BOOLEAN_CONSTANT = 232;
    static readonly STRING_CONSTANT = 233;
    static readonly IDENTIFIER = 234;
    static readonly WS = 235;
    static readonly EOL = 236;
    static readonly ML_COMMENT = 237;
    static readonly SL_COMMENT = 238;
    static readonly channelNames: string[];
    static readonly modeNames: string[];
    static readonly ruleNames: string[];
    private static readonly _LITERAL_NAMES;
    private static readonly _SYMBOLIC_NAMES;
    static readonly VOCABULARY: Vocabulary;
    get vocabulary(): Vocabulary;
    constructor(input: CharStream);
    get grammarFileName(): string;
    get ruleNames(): string[];
    get serializedATN(): string;
    get channelNames(): string[];
    get modeNames(): string[];
    private static readonly _serializedATNSegments;
    private static readonly _serializedATNSegment0;
    private static readonly _serializedATNSegment1;
    private static readonly _serializedATNSegment2;
    private static readonly _serializedATNSegment3;
    static readonly _serializedATN: string;
    static __ATN: ATN;
    static get _ATN(): ATN;
}
